/**
 *
 * Copyright (C) 2013 Olivier Berthier
 *                    http://www.xunil.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 **/
// Blob
// Changelog 05.01.24

// Blob include
#include "blobtriangle.h"
//#include "vector.h"
/*!
  \brief Create a point skeletal element.
  \param c Center.
  \param blend Blending function.
*/
BlobTriangle::BlobTriangle(const Vector &c, const Vector& n, const double& rayon,const double& r,const double& s,const Vector& color):center(c),n((n-c)/Norm(n-c)),rayon(rayon), blend(Blend(r,s))
{
  BlobTriangle::color=color;
  BlobTriangle::box=Box(c,rayon+r + 1.0);
}

/*!
  \brief Overloaded to minimize function calls.
*/
double BlobTriangle::Intensity(const Vector& p)
{  
  // Box 
  if (!box.Inside(p)) return 0.0; 

  /*
  double det = a*c-b*b; 
  double s = b*e-c*d; 
  double t = b*d-a*e;
  if ( s+t <= det ){
    if ( s < 0 ) { if ( t < 0 ) { region 4 } else { region 3 } }
    else if ( t < 0 ) { region 5 }
    else { 
      invDet = 1/det;
      s *= invDet;
      t *= invDet;
    }
  }else{
      if ( s < 0 ) { region 2 }
      else if ( t < 0 ) { region 6 }
      else { region 1 }
  }
*/
  return 0;
}


Vector BlobTriangle::Color(const Vector& p){
  return color;
}
