/**
 *
 * Copyright (C) 2013 Olivier Berthier
 *                    http://www.xunil.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 **/

#include "scene.h"


scene::scene(){}
scene::scene(const scene& s):L(s.L){}
scene::~scene(){
  unsigned int i;
  for(i=0;i<L.size();i++){
    delete L[i];
  }  
}


void scene::init(){
  
  double z=-6.5;
  double z2=-6;
  int nb=40,x,y;
  double d;
  int xmin = -50, xscale = 100, ymin=-50, yscale=100;
  std::vector< std::pair<int,int> > coords(nb);
  std::vector< int > type(nb);
  
  //puit au centre du village
  coords[0]=std::pair<int,int>(0,0);
  type[0]=2;

  for(int i=1;i<nb;i++){
    type[i] = irand(2,0);
    if(type[i]==0)
      d = frand(9,12);
    else
      d = frand(3,10);

  loop:
    x = irand(xscale,xmin);
    y = irand(yscale,ymin);
    for(unsigned int j=0;j<coords.size();j++)
      if(Norm(Vector(coords[j].first,coords[j].second,0)-Vector(x,y,0))<d)
	goto loop;//attention boucle infinie si mauvais parametres
    coords[i]=std::pair<int,int>(x,y);
  }
  L.resize(nb);
  v_cut.resize(nb);
  v_cube.resize(nb);

  std::cout<<"coord OK"<<std::endl;
  
  CMatrix rotation;  

  for(int i=0;i<nb;i++){
    if(type[i]==0){
      CMatrix m;
      m.Rotate(irand(10,-5),1,0,0);
      m.Rotate(irand(10,-5),0,1,0);
      m.Rotate(irand(360,0),0,0,1);    
      L[i] = new blobMaison(Vector(coords[i].first,coords[i].second,z),m);
    }else if(type[i]==1){
      rotation.Rotate(irand(360,0),0,0,1);
      L[i] = new blobSchtroumpf(Vector(coords[i].first,coords[i].second,z2),rotation);
    }else if(type[i]==2){
      L[i] = new blobPuit(Vector(coords[i].first,coords[i].second,-10));
    }
    L[i]->init();
    v_cut[i]=0;
    v_cube[i]=0;
    std::cout<<"Object "<<i<<" OK"<<std::endl;
  }

  L.push_back(new blobGround(Vector(0,0,-10)));
  L.back()->init();
  v_cut.push_back(0);
  v_cube.push_back(0);
  std::cout<<"Ground OK"<<std::endl;
  

  // L.push_back(new blobSchtroumpf());
  // L.back()->init();
  // v_cut.push_back(0);
  // v_cube.push_back(0);

  // L.push_back(new blobMaison());
  // L.back()->init();
  // v_cut.push_back(0);
  // v_cube.push_back(0);

}
void scene::GenerateBlob(){
  unsigned int i;
  for(i=0;i<L.size();i++){
    v_cube[i]=L[i]->GenerateBlob();
  }
}
void scene::GenerateCut(){
  unsigned int i;
  for(i=0;i<L.size();i++){
    v_cut[i]=L[i]->GenerateCut();
  }
}

void scene::Rendering(int blobby, int field){
  unsigned int i;
  for(i=0;i<L.size();i++){
    if (blobby)
      glCallList(v_cube[i]);

    if (field)
      glCallList(v_cut[i]);
    
  }
}

